package com.repair.controller;


import com.repair.api.RepairDispatchRecordControllerAPI;
import com.repair.common.utils.paramUtils;
import com.repair.model.pojo.RepairDispatchRecord;
import com.repair.model.result.CommonResult;
import com.repair.model.result.PageUtils;
import com.repair.services.RepairDispatchRecordService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RestController;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author ceshi
 * @since 2023-07-20
 */
@RestController
public class RepairDispatchRecordController implements RepairDispatchRecordControllerAPI {

    @Autowired
    private RepairDispatchRecordService repairDispatchRecordService;

    /**
     * 新增派单记录
     * @param rc 派单记录
     * @param bindingResult 是否为空判断
     * @return
     */
    @Override
    public CommonResult InsertRepairDispatchRecord(RepairDispatchRecord rc, BindingResult bindingResult) {
        if (bindingResult.hasErrors()) {
            String st = paramUtils.getParamError(bindingResult);
            return CommonResult.fail(st);
        }

        int result = repairDispatchRecordService.insertRepairDispatchRecord(rc);

        return result > 0 ? CommonResult.ok("添加成功") : CommonResult.fail("添加失败");
    }

    /**
     * 根据数据ID更新派单记录
     * @param rc 派单记录
     * @param bindingResult 是否空判断
     * @return
     */
    @Override
    public CommonResult updateRepairDispatchRecordById(RepairDispatchRecord rc, BindingResult bindingResult) {
        if (bindingResult.hasErrors()) {
            String st = paramUtils.getParamError(bindingResult);
            return CommonResult.fail(st);
        }

        int result = repairDispatchRecordService.updateRepairDispatchRecord(rc);

        return result > 0 ? CommonResult.ok("修改成功") : CommonResult.fail("修改失败");
    }

    /**
     * 派单分页数据查询
     * @param currentPage 当前页数
     * @param pageCount 一页数据条数
     * @param name 查询名称
     * @return
     */
    @Override
    public CommonResult queryPageRepairDispatchRecords(int currentPage, int pageCount, String name) {
        PageUtils<RepairDispatchRecord> result = repairDispatchRecordService.queryPageRepairDispatchRecords(currentPage, pageCount, name);

        return CommonResult.ok(result);
    }

    /**
     * 根据数据ID删除派单数据
     * @param id 数据ID
     * @return
     */
    @Override
    public CommonResult deleteRepairDispatchRecordById(int id) {
        RepairDispatchRecord data = repairDispatchRecordService.getRepairById(id);
        if (data == null) {
            return CommonResult.fail("当前数据不存在，删除失败！");
        }

        int result = repairDispatchRecordService.deleteRepairDispatchRecordById(id);

        return result > 0 ? CommonResult.ok("删除成功") : CommonResult.fail("删除失败");
    }
}

